#include "bmslsort.h"
#include <stdio.h>

char *MainFrame::class_name = "BMSLSORT";

bool MainFrame::init( HINSTANCE h_instance ) {
  // EBhENX̍쐬Ao^
  WNDCLASS window_class;
  window_class.style         = CS_HREDRAW | CS_VREDRAW;
  window_class.lpfnWndProc   = TtWindow::_ttl_wnd_proc;
  window_class.cbClsExtra    = 0;
  window_class.cbWndExtra    = 0;
  window_class.hInstance     = h_instance;
  window_class.hIcon         = LoadIcon( h_instance, "MAIN_ICON" );
  window_class.hCursor       = LoadCursor( NULL, IDC_ARROW );
  window_class.hbrBackground = NULL;
  window_class.lpszMenuName  = "MAIN_MENU";
  window_class.lpszClassName = MainFrame::class_name;

  return RegisterClass( &window_class );
}


DWORD  MainFrame::get_ex_style()   { return WS_EX_STATICEDGE | WS_EX_ACCEPTFILES; }
DWORD  MainFrame::get_style()      { return WS_OVERLAPPEDWINDOW; }
PCTSTR MainFrame::get_class_name() { return MainFrame::class_name; }

bool MainFrame::created() {
  HFONT h_font = CreateFont(
    12, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
    SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
    CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY ,
    FIXED_PITCH | FF_MODERN , NULL
    );

  this->headers_back = new TtStatic();
  this->headers_back->create( this, 0, this->h_instance, 0 );
  this->headers_back->set_font( h_font );
  this->headers_back->show();

  this->headers_group = new TtGroup();
  this->headers_group->create( this, 0, this->h_instance, 0 );
  this->headers_group->set_font( h_font );
  this->headers_group->set_text( "HEADERS" );
  this->headers_group->show();

  HeaderSet::set_hash( BMSLSORT::bms->get_headers() );
  HeaderSet::set_font( h_font );
  this->header_sets[0] = new HeaderSet( this, KEY_TITLE,  ID_LABEL_TITLE,  ID_EDIT_TITLE  );
  this->header_sets[1] = new HeaderSet( this, KEY_GENRE,  ID_LABEL_GENRE,  ID_EDIT_GENRE  );
  this->header_sets[2] = new HeaderSet( this, KEY_ARTIST, ID_LABEL_ARTIST, ID_EDIT_ARTIST );

  this->list_tab = new TtTab();
  this->list_tab->create( this, ID_TAB, this->h_instance, 0 );
  this->list_tab->set_font( h_font );
  this->list_tab->show();

  this->list_sets[0] = new ListSet( BMSLSORT::bms, BmsRegistArray::TYPE_WAV );
  this->list_sets[0]->create( this, ID_LIST_WAV, this->h_instance, 0 );
  this->list_tab->insert_at( 0, this->list_sets[0]->get_bms_ary()->get_name() );
  this->list_tab->set_under( this->list_sets[0]->get_h_wnd() );
  this->list_sets[0]->set_font( h_font );
  this->list_sets[0]->show();

  this->list_sets[1] = new ListSet( BMSLSORT::bms, BmsRegistArray::TYPE_BMP );
  this->list_sets[1]->create( this, ID_LIST_BMP, this->h_instance, 0 );
  this->list_tab->insert_at( 1, this->list_sets[1]->get_bms_ary()->get_name() );
  this->list_tab->set_under( this->list_sets[1]->get_h_wnd() );
  this->list_sets[1]->set_font( h_font );

  return true;
}

LRESULT MainFrame::wm_size_recved( int flag, int width, int height ) {
  flag; // x}~̈
  this->headers_back->set_pos_size( 0, 0, HeaderSet::WIDTH, height );
  this->headers_group->set_pos_size( 0, 0, HeaderSet::WIDTH, height );
  this->list_tab->set_pos_size( HeaderSet::WIDTH, 0, width - HeaderSet::WIDTH, height );

  RECT rect;
  rect = this->list_tab->get_view_rect();
  rect.left  += HeaderSet::WIDTH;
  rect.right += HeaderSet::WIDTH;
  this->list_sets[0]->set_rect( rect );
  this->list_sets[1]->set_rect( rect );

  return 0;
}


LRESULT MainFrame::wm_command_recved( int id, int code, HWND child ) {
  child; // x}~̈
  switch ( id ) {
  case IDM_END:
    this->close();
    return 0;

  case IDM_NEW:
    delete BMSLSORT::bms;
    BMSLSORT::bms = new BmsBms();
    BMSLSORT::now_bms_path[0] = '\0';
    this->repaint_all();
    return 0;

  case IDM_OPEN:
    if ( !BMSLSORT::get_open_filename( this->h_wnd, BMSLSORT::buf, sizeof( BMSLSORT::buf ) ) ) { return 0; }
    this->open_bms( BMSLSORT::buf );
    return 0;
    
  case IDM_SAVE_AS:
    if ( !BMSLSORT::get_save_filename( this->h_wnd, BMSLSORT::buf, sizeof( BMSLSORT::buf ) ) ) { return 0; }
    this->save_bms( BMSLSORT::buf );
    return 0;

  case IDM_SAVE:
    if ( BMSLSORT::now_bms_path[0] == '\0' &&
         !BMSLSORT::get_save_filename( this->h_wnd, BMSLSORT::buf, sizeof( BMSLSORT::buf ) ) ) { return 0; }
    this->save_bms( BMSLSORT::buf );
    return 0;

  case IDM_EXCHANGE:
    this->list_sets[this->list_tab->get_current()]->exchange_upper();
    return 0;

  case IDM_NOUSE_WAV:
    this->list_sets[0]->no_use_erase();
    return 0;

  case IDM_NOUSE_BMP:
    this->list_sets[1]->no_use_erase();
    return 0;

  case IDM_FILL_WAV:
    this->list_sets[0]->fill();
    return 0;

  case IDM_FILL_BMP:
    this->list_sets[1]->fill();
    return 0;

  case IDM_HOW_TO_USE:
    MessageBox( this->h_wnd, "ꏏɂeLXgt@C݂", "g", MB_ICONINFORMATION );
    return 0;

  case IDM_VERSION:
    DialogBox( this->h_instance, "VERSION_DIALOG", this->h_wnd, BMSLSORT::version_dialog_proc );
    return 0;

  case ID_EDIT_TITLE:
  case ID_EDIT_GENRE:
  case ID_EDIT_ARTIST:
    switch ( code ) {
    case EN_UPDATE:
      HeaderSet::find_id( id )->update_hash();
      return 0;
    }
  }
  return TTL_DEFAULT;
}





LRESULT MainFrame::wm_notify_recved( int id, NMHDR *nmhdr ) {
  id; // x}~̈
  static int current;

  switch ( nmhdr->idFrom ) {
  case ID_TAB:
    switch ( nmhdr->code ) {
    case TCN_SELCHANGE:
      this->list_sets[current]->hide();
      current = this->list_tab->get_current();
      this->list_sets[current]->show();
      return 0;
    }
    return TTL_DEFAULT;

  }
  return TTL_DEFAULT;
}


LRESULT MainFrame::wm_destroy_recved() {
  WINDOWPLACEMENT place;
  GetWindowPlacement( this->h_wnd, &place );
  if ( place.showCmd == SW_SHOWMINIMIZED ) { place.showCmd = SW_SHOWNORMAL; }
  sprintf( BMSLSORT::buf, "%s=%d%c%s=%d%c%s=%d%c%s=%d%c%s=%d%c",
           INI_WIN_POS_X,  place.rcNormalPosition.left, '\0',
           INI_WIN_POS_Y,  place.rcNormalPosition.top,  '\0',
           INI_WIN_WIDTH,  place.rcNormalPosition.right - place.rcNormalPosition.left, '\0',
           INI_WIN_HEIGHT, place.rcNormalPosition.bottom - place.rcNormalPosition.top, '\0',
           INI_WIN_STATE,  place.showCmd, '\0' );
  WritePrivateProfileSection( INI_SECTION_WIN, BMSLSORT::buf, BMSLSORT::ini_file_path );

  PostQuitMessage(0);
  return 0;
}


LRESULT MainFrame::wm_dropfiles_recved( HDROP h_drop ) {
  this->set_forground();

  DragQueryFile( h_drop, 0, BMSLSORT::buf, sizeof( BMSLSORT::buf ) );
  this->open_bms( BMSLSORT::buf );
  DragFinish( h_drop );
  return 0;
}


LRESULT MainFrame::wnd_proc( UINT msg, WPARAM w_param, LPARAM l_param ) {
  LRESULT ret;
  switch ( msg ) {
  case WM_DROPFILES:
    ret = this->wm_dropfiles_recved( (HDROP)w_param );
    if ( ret != TTL_DEFAULT ) { return ret; } else { break; }

  }
  return TtApp::wnd_proc( msg, w_param, l_param );
}


void MainFrame::repaint_all() {

  HeaderSet::set_hash( BMSLSORT::bms->get_headers() );
  this->list_sets[0]->set_bms( BMSLSORT::bms );
  this->list_sets[1]->set_bms( BMSLSORT::bms );
  
  sprintf( BMSLSORT::buf, "%s  %s", APP_NAME, BMSLSORT::now_bms_path );
  this->set_text( BMSLSORT::buf );
  HeaderSet::repaint_edit_all();

  this->list_sets[0]->repaint_all();
  this->list_sets[1]->repaint_all();

  return;
}


void MainFrame::open_bms( char *path ) {
  bool status;
  BmsBms *new_bms;

  status = BmsLexer::read_file( path, &new_bms );
  if ( !status ) {
    MessageBox( this->h_wnd, "BMSt@C̉͂Ɏs܂B", "ERROR", MB_ICONERROR );
    return;
  }
  delete BMSLSORT::bms;
  BMSLSORT::bms = new_bms;

  strcpy( BMSLSORT::now_bms_path, path );
  strcpy( BMSLSORT::now_bms_path_dir, path );
  BMSLSORT::edit_path( BMSLSORT::now_bms_path_dir, true, true, false, false );

  this->repaint_all();
  return;
}

void MainFrame::save_bms( char *path ) {
  bool status;

  status = BmsLexer::write_file( path, BMSLSORT::bms );
  if ( !status ) {
    MessageBox( this->h_wnd, "BMSt@C̕ۑɎs܂B", "ERROR", MB_ICONERROR );
    return;
  }

  strcpy( BMSLSORT::now_bms_path, path );
  strcpy( BMSLSORT::now_bms_path_dir, path );
  BMSLSORT::edit_path( BMSLSORT::now_bms_path_dir, true, true, false, false );
  return;
}
